
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Smart_link_destinationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const smart_link_destinations = await db.smart_link_destinations.create(
            {
                id: data.id || undefined,
        
        destination_url: data.destination_url
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_primary: data.is_primary
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await smart_link_destinations.setSmart_link( data.smart_link || null, {
            transaction,
        });
        
        await smart_link_destinations.setPlatform( data.platform || null, {
            transaction,
        });
        
        await smart_link_destinations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return smart_link_destinations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const smart_link_destinationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                destination_url: item.destination_url
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_primary: item.is_primary
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const smart_link_destinations = await db.smart_link_destinations.bulkCreate(smart_link_destinationsData, { transaction });

        // For each item created, replace relation files
        

        return smart_link_destinations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const smart_link_destinations = await db.smart_link_destinations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.destination_url !== undefined) updatePayload.destination_url = data.destination_url;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_primary !== undefined) updatePayload.is_primary = data.is_primary;
        
        
        updatePayload.updatedById = currentUser.id;

        await smart_link_destinations.update(updatePayload, {transaction});

        
        
        if (data.smart_link !== undefined) {
            await smart_link_destinations.setSmart_link(
              
              data.smart_link,
              
              { transaction }
            );
        }
        
        if (data.platform !== undefined) {
            await smart_link_destinations.setPlatform(
              
              data.platform,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await smart_link_destinations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return smart_link_destinations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const smart_link_destinations = await db.smart_link_destinations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of smart_link_destinations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of smart_link_destinations) {
                await record.destroy({transaction});
            }
        });


        return smart_link_destinations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const smart_link_destinations = await db.smart_link_destinations.findByPk(id, options);

        await smart_link_destinations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await smart_link_destinations.destroy({
            transaction
        });

        return smart_link_destinations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const smart_link_destinations = await db.smart_link_destinations.findOne(
            { where },
            { transaction },
        );

        if (!smart_link_destinations) {
            return smart_link_destinations;
        }

        const output = smart_link_destinations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.smart_link = await smart_link_destinations.getSmart_link({
            transaction
        });
        
        
        output.platform = await smart_link_destinations.getPlatform({
            transaction
        });
        
        
        output.organizations = await smart_link_destinations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.smart_links,
        as: 'smart_link',
        
        where: filter.smart_link ? {
          [Op.or]: [
            { id: { [Op.in]: filter.smart_link.split('|').map(term => Utils.uuid(term)) } },
            {
              slug: {
                [Op.or]: filter.smart_link.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.distribution_platforms,
        as: 'platform',
        
        where: filter.platform ? {
          [Op.or]: [
            { id: { [Op.in]: filter.platform.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.platform.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.destination_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'smart_link_destinations',
                        'destination_url',
                        filter.destination_url,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_primary) {
                where = {
                    ...where,
                is_primary: filter.is_primary,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.smart_link_destinations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'smart_link_destinations',
                        'destination_url',
                        query,
                    ),
                ],
            };
        }

        const records = await db.smart_link_destinations.findAll({
            attributes: [ 'id', 'destination_url' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['destination_url', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.destination_url,
        }));
    }

    
};

